
QGIS Application - Bug report #3714

Qt arguments are not supported

2011-04-09 11:14 AM - Martin Dobias

Status: Closed

Priority: Low

Assignee:

Category: GUI

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 13773

Description

QApplication is able to parse some useful command line arguments such as -style, -stylesheet, -session or -graphicssystem, but QGIS

does not support them because it parses arguments before Qt has a chance to check (and remove) them. Instead it complains about

invalid arguments.

(Additionally it would be good to unify handling of arguments for unix and windows.)

Associated revisions

Revision 42ea15b3 - 2016-01-27 12:42 PM - Martin Dobias

Merge pull request #2496 from SebDieBln/App_OptionsAsFiles

Accept option '--' to mark all following arguments as files (refs #3714)

History

#1 - 2011-12-16 12:45 PM - Giovanni Manghi

- Target version changed from Version 1.7.0 to Version 1.7.4

#2 - 2012-04-16 06:27 AM - Paolo Cavallini

- Target version changed from Version 1.7.4 to Version 1.8.0

- Affected QGIS version set to master

- Crashes QGIS or corrupts data set to No

#3 - 2012-09-04 12:00 PM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#4 - 2014-06-28 07:38 AM - Jürgen Fischer

- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#5 - 2015-11-20 07:14 AM - Médéric RIBREUX

- % Done changed from 0 to 50

- Status changed from Open to Feedback

- Assignee deleted (nobody -)

- Pull Request or Patch supplied set to No

Hello, bug triage...
something has been done on this bug because I am able to launch QGIS 2.13 master with the -reverse QApplication argument. With this option, QGIS

menus and panels are oriented from right to left (or inverse). So it seems that QApplication arguments are used by QGIS application.

But with this option, QGIS still complains about the fact that the layer ~/-reverse is not valid !

We need a better QApplication argument detection (and management)...

#6 - 2015-11-21 02:42 AM - Sebastian Dietrich

If I am right, the cause for this issue is some two step initialization:

    -  instantiate a dummy QCoreApplication object

    -  parse the arguments

    -  instantiate the actual QgsApplication object

So when given the -reverse argument, it is:

    -  ignored by QCoreApplication

    -  evaluated by QGIS, leading to the mentioned complaint

    -  accepted by QgsApplication via inheritance of QApplication

thus leading to a complaint and the expected behaviour.

See PR 2491 for a possible solution.

#7 - 2015-11-21 06:20 AM - Sebastian Dietrich

There are two other interesting questions here:

    -  How do I specify a layer by the name of -reverse (preventing QApplication from interpreting it)?

    -  How do I specify a layer by the name of --help (preventing QGIS from interpreting it)?

#8 - 2015-11-22 10:04 AM - Sebastian Dietrich

Looking at the Qt sources it appears there is no simple solution for -reverse and other Qt options. QApplication always parses all arguments, eating up all

it can handle.

For --help and other QGIS options see PR 2496, introducing '--' as an additional option to mark all following arguments as files.

#9 - 2015-12-26 06:37 AM - Giovanni Manghi

- Status info deleted (0)

- Status changed from Feedback to Open

- Operating System deleted (All)

#10 - 2016-01-12 04:23 PM - Sebastian Dietrich

- % Done changed from 50 to 70

- Pull Request or Patch supplied changed from No to Yes

#11 - 2016-01-26 03:19 AM - Martin Dobias

Thanks for the work, Sebastian!

I think my preference would be to defer solving this to QGIS 3 for two reasons:

- Qt5 comes with nice and shiny QCommandLineParser class to do parsing for us

2024-04-26 2/3

https://github.com/qgis/QGIS/blob/ca3da4ceee1cb7d23ad2503f0254e4bca23e47bd/src/app/main.cpp#L529
https://github.com/qgis/QGIS/blob/ca3da4ceee1cb7d23ad2503f0254e4bca23e47bd/src/app/main.cpp#L530-L691
https://github.com/qgis/QGIS/blob/ca3da4ceee1cb7d23ad2503f0254e4bca23e47bd/src/app/main.cpp#L751
https://github.com/qgis/QGIS/pull/2491
https://github.com/qgis/QGIS/pull/2496


- bootstrapping of QGIS is already quite complicated. I would like to simplify it, see https://github.com/qgis/qgis3.0_api/issues/9

#12 - 2016-01-26 03:20 PM - Sebastian Dietrich

QCommandLineParser really looks promising!

How do you feel about merging only PR 2496? It implements the same behaviour like QCommandLineParser, which will treat everything after the option --

(double dash) as positional arguments.

#13 - 2016-01-27 03:44 AM - Martin Dobias

Sounds good - I have merged PR 2469 and let's keep the other PR open...

#14 - 2016-01-27 05:18 AM - Sebastian Dietrich

Martin Dobias wrote:

Sounds good - I have merged PR 2469 and let's keep the other PR open...

Thanks, that makes sense.

#15 - 2017-05-01 01:10 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#16 - 2019-03-09 04:04 PM - Giovanni Manghi

- Status changed from Open to Closed

- Resolution set to end of life

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/
https://github.com/qgis/qgis3.0_api/issues/9
http://doc.qt.io/qt-5/qcommandlineparser.html
https://github.com/qgis/QGIS/pull/2496
http://doc.qt.io/qt-5/qcommandlineparser.html#details
http://doc.qt.io/qt-5/qcommandlineparser.html#details
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

